// PedalController.h
#ifndef PEDALCONTROLLER_H
#define PEDALCONTROLLER_H

#include <Arduino.h>

// Calibration state enumeration
enum CalibrationState {
    IDLE,
    RUNNING,
    SUCCESS,
    ERROR
};

// Pedal configuration structure
struct PedalConfig {
    int minRaw;
    int maxRaw;
    bool calibrated;
    int filterStrength;
};

class PedalController {
private:
    int pedalPin;
    int filteredValue;
    PedalConfig config;

    int applySmoothing(int rawValue);
    int getRawValue();

public:
    PedalController(int pin);
    
    CalibrationState autoCalibrate(bool reset);
    CalibrationState getStatus();

    int getPedal();

    PedalConfig getConfig();
    void setConfig(const PedalConfig &newConfig);
    void loadDefaults();

};

#endif // PEDALCONTROLLER_H
